%define pkgname xorg-server
%define cvsdate cvsYYYYMMDD
Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	X.Org X11 X server
Name:      	xorg-x11-server
Version:   	1.9.3
Release:   	1
URL:       	http://www.x.org
License:   	MIT/X11
Group:     	User Interface/X
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:	i686
Source0:   	ftp://ftp.x.org/pub/individual/xserver/%{pkgname}-%{version}.tar.bz2
Source100: 	comment-header-modefiles.txt

%define moduledir	%{_libdir}/xorg/modules
%define drimoduledir	%{_libdir}/dri
%define sdkdir		%{_includedir}/xorg

%ifarch %{ix86} x86_64
%define xservers --enable-xorg --enable-dmx --enable-xvfb --enable-xnest --enable-kdrive --enable-xephyr
%define with_hw_servers 1
%define with_dmx_server 1
%endif

# NOTE: The developer utils are intended for low level video driver hackers,
# doing low level bit twiddling, who really know what they are doing, and are
# disabled by default, as they are not generally useful to end users.
# FIXME: Reconfigure the spec file to put them in a separate subpackage, so
# I can build one build with them enabled, install them, then disable it again.
%define with_developer_utils	0

%ifarch %{ix86} x86_64
%define with_dri	1
%endif

# FIXME: Temporary Build deps on autotools, as needed...
#BuildRequires: automake17
BuildRequires: 	automake
BuildRequires: 	autoconf
BuildRequires: 	libtool
BuildRequires:	sysfsutils-devel

BuildRequires: 	pkg-config
BuildRequires: 	xorg-x11-util-macros
BuildRequires: 	xorg-x11-proto-devel
BuildRequires: 	xorg-x11-xtrans-devel
BuildRequires: 	libxkbfile-devel
# libXres-devel needed for something that links to libXres that I never bothered to figure out yet
BuildRequires: 	libXres-devel
# libfontenc-devel needed for Xorg, but not specified by
# upstream deps.  Build fails without it.
BuildRequires: 	libfontenc-devel
# Required for Xtst examples
BuildRequires: 	libXtst-devel
# libXdmcp-devel needed for Xdmx, Xnest, Xephyr
BuildRequires: 	libXdmcp-devel
# libX11-devel needed for Xdmx, Xnest, Xephyr
BuildRequires: 	libX11-devel
# libXext-devel needed for Xdmx, Xnest, Xephyr
BuildRequires: 	libXext-devel
#
BuildRequires: 	freetype-devel

BuildRequires:  libpthread-stubs

%if %{with_dmx_server}
# libdmx-devel needed for Xdmx
BuildRequires: 	libdmx-devel
# libXmu-devel needed for Xdmx
BuildRequires: 	libXmu-devel
# libXrender-devel needed for Xdmx
BuildRequires: 	libXrender-devel
# libXi-devel needed for Xdmx
BuildRequires: 	libXi-devel
BuildRequires: 	libXpm-devel
BuildRequires: 	libXaw-devel
%endif

# To query fontdir from fontutil.pc
BuildRequires: 	xorg-x11-font-utils
# Needed at least for DRI enabled builds
%if %{with_dri}
BuildRequires: 	mesa-libGL-devel
BuildRequires: 	mesa-source
BuildRequires: 	libdrm-devel
%endif

#Automatically resolved build dependencies
BuildRequires: DirectFB-devel


BuildRequires: libXxf86vm-devel
BuildRequires: libXdamage-devel
BuildRequires: libsmbios-devel
BuildRequires: flex-devel

# Don`t activate udev just yet, our version of udev is not recent enough
#uildRequires: libudev-devel

# Make sure we pull ABI compatible drivers.
Conflicts: xorg-x11-drv-ati < 6.6.1
Conflicts: xorg-x11-drv-i810 < 1.6.0

#Automatically resolved build dependencies
BuildRequires: dbus-devel
BuildRequires: glibc-devel
BuildRequires: hal-devel
BuildRequires: libdrm-devel
BuildRequires: libfontenc-devel
BuildRequires: libgcc
BuildRequires: libpciaccess-devel
BuildRequires: libX11-devel
BuildRequires: libXau-devel
BuildRequires: libXaw-devel
BuildRequires: libXdmcp-devel
BuildRequires: libXext-devel
BuildRequires: libXfixes-devel
BuildRequires: libXfont-devel
BuildRequires: libXi-devel
BuildRequires: libXmu-devel
BuildRequires: libXpm-devel
BuildRequires: libXrender-devel
BuildRequires: libXt-devel
BuildRequires: libXv-devel
BuildRequires: mesa-libGL-devel
BuildRequires: openssl-devel
BuildRequires: pixman-devel
BuildRequires: SDL-devel
BuildRequires: zlib-devel

%description
X.Org X11 X server

# ----- Xorg --------------------------------------------------------
%if %{with_hw_servers}
%package Xorg
Summary: Xorg X server
Group: User Interface/X
# NOTE: The X server invokes xkbcomp directly, so this is required.
Requires: xkbcomp
# NOTE: The X server requires 'fixed' and 'cursor' font, which are provided
# by xorg-x11-fonts-base
Requires: xorg-x11-fonts-base
# NOTE: Require some basic drivers for minimal configuration. (#173060)
# We _should_ install every driver, but OLPC wants different (#191781),
# which is quite lame and wants an better solution.
Requires: xorg-x11-drv-mouse xorg-x11-drv-keyboard xorg-x11-drv-vesa
Requires: xorg-x11-drv-void xorg-x11-drv-evdev xorg-x11-drv-fbdev
Requires: xorg-x11-drv-nv xorg-x11-drv-ati
Requires: xorg-x11-xinit
#Requires: xorg-x11-drivers >= 0.99.2-4

# NOTE: We use implementation non-specific "xkbdata" here, to make it easy
# to switch to the freedesktop.org 'xkeyboard-config' project replacment
# in the future.
Requires: xkbdata
# FIXME: Investigate these two and see what utils are needed, and use virtuals
Requires: xorg-x11-server-utils
Requires: xorg-x11-utils
# FIXME: This Requires on libXfont can be removed from here in the future,
# as it is not really mandatory, but forces a bugfix workaround on people who
# are using pre-rawhide modular X.
Requires: libXfont

Obsoletes: XFree86 xorg xorg-devel xorg-static xorg-libs
# NOTE: This virtual provide should be used when one wants to depend on
# the implementation specific (and optionally version specific) Xorg X
# server, but in an OS packaging independent manner.  This futureproofs
# package dependencies against possible future Xorg package renaming.
Provides: Xorg = %{version}-%{release}
Provides: Xserver

%description Xorg
X.org X11 is an open source implementation of the X Window System.  It
provides the basic low level functionality which full fledged
graphical user interfaces (GUIs) such as GNOME and KDE are designed
upon.
%endif

# ----- Xnest -------------------------------------------------------
%package Xnest
Summary: A nested server.
Group: User Interface/X
#Requires: %{name} = %{version}-%{release}
Obsoletes: XFree86-Xnest, xorg-Xnest
# NOTE: This virtual provide should be used by packages which want to depend
# on an implementation nonspecific Xnest X server.  It is intentionally not
# versioned, since it should be agnostic.
Provides: Xnest

%description Xnest
Xnest is an X server, which has been implemented as an ordinary
X application.  It runs in a window just like other X applications,
but it is an X server itself in which you can run other software.  It
is a very useful tool for developers who wish to test their
applications without running them on their real X server.

# ----- Xdmx --------------------------------------------------------
%if %{with_dmx_server}
%package Xdmx
Summary: Distributed Multihead X Server and utilities
Group: User Interface/X
#Requires: %{name}-Xorg = %{version}-%{release}
Obsoletes: xorg-Xdmx
# NOTE: This virtual provide should be used by packages which want to depend
# on an implementation nonspecific Xdmx X server.  It is intentionally not
# versioned, since it should be agnostic.
Provides: Xdmx

%description Xdmx
Xdmx is proxy X server that provides multi-head support for multiple displays
attached to different machines (each of which is running a typical X server).
When Xinerama is used with Xdmx, the multiple displays on multiple machines
are presented to the user as a single unified screen.  A simple application
for Xdmx would be to provide multi-head support using two desktop machines,
each of which has a single display device attached to it.  A complex
application for Xdmx would be to unify a 4 by 4 grid of 1280x1024 displays
(each attached to one of 16 computers) into a unified 5120x4096 display.
%endif
# ----- Xvfb --------------------------------------------------------

%package Xvfb
Summary: A X Windows System virtual framebuffer X server.
Group: User Interface/X
Obsoletes: XFree86-Xvfb xorg-Xvfb
# NOTE: This virtual provide should be used by packages which want to depend
# on an implementation nonspecific Xvfb X server.  It is intentionally not
# versioned, since it should be agnostic.
Provides: Xvfb

%description Xvfb
Xvfb (X Virtual Frame Buffer) is an X server that is able to run on
machines with no display hardware and no physical input devices.
Xvfb simulates a dumb framebuffer using virtual memory.  Xvfb does
not open any devices, but behaves otherwise as an X display.  Xvfb
is normally used for testing servers.

# ----- Xephyr -------------------------------------------------------

%package Xephyr
Summary: A nested server.
Group: User Interface/X
#Requires: %{name} = %{version}-%{release}
# NOTE: This virtual provide should be used by packages which want to depend
# on an implementation nonspecific Xephyr X server.  It is intentionally not
# versioned, since it should be agnostic.
Provides: Xephyr

%description Xephyr
Xephyr is an X server, which has been implemented as an ordinary
X application.  It runs in a window just like other X applications,
but it is an X server itself in which you can run other software.  It
is a very useful tool for developers who wish to test their
applications without running them on their real X server.  Unlike
Xnest, Xephyr renders to an X image rather than relaying the
X protocol, and therefore supports the newer X extensions like
Render and Composite.

# ----- sdk ---------------------------------------------------------
%if %{with_hw_servers}
%package sdk
Summary: SDK for X server driver module development
Group: User Interface/X
Obsoletes: XFree86-sdk xorg-sdk
Requires: xorg-x11-util-macros
Requires: xorg-x11-proto-devel

Requires(pre): xorg-x11-filesystem >= 0.99.2-3

Provides: libxf86config-devel = %{version}-%{release}

%description sdk
The SDK package provides the developmental files which are necessary for
developing X server driver modules, and for compiling driver modules
outside of the standard X11 source code tree.  Developers writing video
drivers, input drivers, or other X modules should install this package.
%endif
# -------------------------------------------------------------------

%prep
%setup -q -n %{pkgname}-%{version}
 
%build
FONTDIR="%{_datadir}/fonts/X11"
DEFAULT_FONT_PATH="${FONTDIR}/misc:unscaled,${FONTDIR}/TTF/,${FONTDIR}/OTF,${FONTDIR}/Type1/,${FONTDIR}/CID/,${FONTDIR}/100dpi:unscaled,${FONTDIR}/75dpi:unscaled"

#	--disable-dependency-tracking \
# also, --enable-kdrive just for Xephyr is overkill, should fix that upstream

#aclocal ; libtoolize; autoreconf; automake --add-missing
./autogen.sh
%configure %{xservers} \
	--disable-xprint \
	--disable-static \
	--with-pic \
        --enable-aiglx \
        --enable-record \
	--enable-composite \
	--enable-xtrap \
	--enable-xcsecurity \
	--enable-xevie \
	--enable-fontcache \
	--with-default-font-path="$DEFAULT_FONT_PATH,unix/:7100" \
	--with-module-dir=%{moduledir} \
	--with-os-name="CCux Linux" \
	--with-os-vendor="CCux Linux" \
	--with-builderstring="Build ID: %{name} %{version}-%{release}" \
	--with-xkb-output=%{_localstatedir}/lib/xkb \
	--with-rgb-path=%{_datadir}/X11/rgb \
	--disable-xorgcfg \
	--with-fontdir=%(pkg-config --variable=fontdir fontutil) \
%if %{with_dri}
	--enable-dri \
	--enable-dri2 \
	--with-mesa-source=%{_datadir}/mesa/source \
	--with-dri-driver-path=%{drimoduledir} \
%else
	--disable-dri \
%endif

# --enable-install-libxf86config \

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT moduledir=%{moduledir}


%if %{with_hw_servers}
# FIXME: This should be done upstream, so it's one less thing to hack.
# Make these directories now so the Xorg package can own them.
mkdir -p $RPM_BUILD_ROOT%{_libdir}/xorg/modules/{drivers,input}

# Install the vesamodes and extramodes files to let our install/config tools
# be able to parse the same modelist as the X server uses (rhpxl).
{
    mkdir -p $RPM_BUILD_ROOT%{_datadir}/xorg
    for each in vesamodes extramodes ; do
        install -m 0644 %{SOURCE100} $RPM_BUILD_ROOT%{_datadir}/xorg/$each
        cat hw/xfree86/common/$each >> $RPM_BUILD_ROOT%{_datadir}/xorg/$each
        chmod 0444 $RPM_BUILD_ROOT%{_datadir}/xorg/$each
    done
}
%endif

# FIXME: Remove unwanted files/dirs
{
    rm -f $RPM_BUILD_ROOT%{_bindir}/xorgconfig
    rm -f $RPM_BUILD_ROOT%{_mandir}/man1/xorgconfig.1*
    rm -f $RPM_BUILD_ROOT%{_libdir}/X11/Cards
    rm -f $RPM_BUILD_ROOT%{_libdir}/X11/Options
    rm -f $RPM_BUILD_ROOT%{_libdir}/X11/getconfig/cfg.sample
    rm -f $RPM_BUILD_ROOT%{_libdir}/X11/getconfig/xorg.cfg
#    rm -f $RPM_BUILD_ROOT%{_bindir}/getconfig
#    rm -f $RPM_BUILD_ROOT%{_bindir}/getconfig.pl
%if ! %{with_developer_utils}
    rm -f $RPM_BUILD_ROOT%{_bindir}/inb
    rm -f $RPM_BUILD_ROOT%{_bindir}/inl
    rm -f $RPM_BUILD_ROOT%{_bindir}/inw
    rm -f $RPM_BUILD_ROOT%{_bindir}/ioport
    rm -f $RPM_BUILD_ROOT%{_bindir}/outb
    rm -f $RPM_BUILD_ROOT%{_bindir}/outl
    rm -f $RPM_BUILD_ROOT%{_bindir}/outw
    rm -f $RPM_BUILD_ROOT%{_bindir}/pcitweak
#    rm -f $RPM_BUILD_ROOT%{_mandir}/man1/pcitweak.1*
%endif
#    rm -f $RPM_BUILD_ROOT%{_mandir}/man1/getconfig.1x*
#    rm -f $RPM_BUILD_ROOT%{_mandir}/man5/getconfig.5x*
    # Remove all libtool archives (*.la)
    find $RPM_BUILD_ROOT -type f -name '*.la' | xargs rm -f -- || :
}

%clean
rm -rf $RPM_BUILD_ROOT

# ----- Xorg --------------------------------------------------------

%if %{with_hw_servers}
%files Xorg
%defattr(-,root,root,-)
%{_bindir}/X
%{_bindir}/Xfbdev
%attr(4711, root, root) %{_bindir}/Xorg
%{_bindir}/gtf
%{_bindir}/cvt
%if %{with_developer_utils}
%{_bindir}/inb
%{_bindir}/inl
%{_bindir}/inw
%{_bindir}/ioport
%{_bindir}/outb
%{_bindir}/outl
%{_bindir}/outw
%{_bindir}/pcitweak
%endif
%{_datadir}/xorg/vesamodes
%{_datadir}/xorg/extramodes
%dir %{_libdir}/xorg
%dir %{_libdir}/xorg/modules
%{_libdir}/xorg/modules/libwfb.so
%dir %{_libdir}/xorg/modules/drivers
%dir %{_libdir}/xorg/modules/extensions
%if %{with_dri}
%{_libdir}/xorg/modules/extensions/libdri.so
%{_libdir}/xorg/modules/extensions/libdri2.so
%{_libdir}/xorg/modules/extensions/libglx.so
%endif
%{_libdir}/xorg/modules/extensions/libdbe.so
%{_libdir}/xorg/modules/extensions/libextmod.so
%{_libdir}/xorg/modules/extensions/librecord.so
%dir %{_libdir}/xorg/modules/input
%{_libdir}/xorg/modules/libfbdevhw.so
%dir %{_libdir}/xorg/modules/multimedia
%{_libdir}/xorg/modules/multimedia/bt829_drv.so
%{_libdir}/xorg/modules/multimedia/fi1236_drv.so
%{_libdir}/xorg/modules/multimedia/msp3430_drv.so
%{_libdir}/xorg/modules/multimedia/tda8425_drv.so
%{_libdir}/xorg/modules/multimedia/tda9850_drv.so
%{_libdir}/xorg/modules/multimedia/tda9885_drv.so
%{_libdir}/xorg/modules/multimedia/uda1380_drv.so
%{_libdir}/xorg/modules/libexa.so
%{_libdir}/xorg/modules/libfb.so
%{_libdir}/xorg/modules/libint10.so
%{_libdir}/xorg/modules/libshadow.so
%{_libdir}/xorg/modules/libshadowfb.so
%{_libdir}/xorg/modules/libvbe.so
%{_libdir}/xorg/modules/libvgahw.so
%{_libdir}/xorg/modules/libxaa.so
%{_libdir}/xorg/modules/libxf8_16bpp.so
%{_libdir}/xorg/protocol.txt
%{_mandir}/man1/gtf.1.gz
%{_mandir}/man1/Xorg.1.gz
%{_mandir}/man1/Xserver.1.gz
%{_mandir}/man1/cvt.1.gz
%{_mandir}/man4/exa.4.gz
%{_mandir}/man4/fbdevhw.4.gz
%{_mandir}/man5/xorg.conf.5.gz
#%{_datadir}/X11/xorg.conf.d/10-evdev.conf
#%{_sysconfdir}/dbus-1/system.d/xorg-server.conf
%{_localstatedir}/lib/xkb/README.compiled
%endif

# ----- Xnest -------------------------------------------------------

%files Xnest
%defattr(-,root,root,-)
%{_bindir}/Xnest
%{_mandir}/man1/Xnest.1.gz

# ----- Xdmx --------------------------------------------------------

%if %{with_dmx_server}
%files Xdmx
%defattr(-,root,root,-)
%{_bindir}/Xdmx
%{_bindir}/dmxaddinput
%{_bindir}/dmxaddscreen
%{_bindir}/dmxreconfig
%{_bindir}/dmxresize
%{_bindir}/dmxrminput
%{_bindir}/dmxrmscreen
%{_bindir}/dmxtodmx
%{_bindir}/dmxwininfo
%{_bindir}/vdltodmx
%{_bindir}/dmxinfo
%{_bindir}/xdmxconfig
%{_mandir}/man1/Xdmx.1.gz
%{_mandir}/man1/xdmxconfig.1.gz
%{_mandir}/man1/dmxtodmx.1.gz
%{_mandir}/man1/vdltodmx.1.gz
%endif

# ----- Xvfb --------------------------------------------------------

%files Xvfb
%defattr(-,root,root,-)
%{_bindir}/Xvfb
%{_mandir}/man1/Xvfb.1.gz

# ----- Xephyr -------------------------------------------------------

%files Xephyr
%defattr(-,root,root,-)
%{_bindir}/Xephyr
%{_mandir}/man1/Xephyr.1.gz

# ----- sdk ---------------------------------------------------------
%if %{with_hw_servers}
%files sdk
%defattr(-,root,root,-)
%{_pkgconfig}/xorg-server.pc
%{_includedir}/xorg
%{_datadir}/aclocal/xorg-server.m4
%endif
# -------------------------------------------------------------------

%changelog
* Thu Dec 16 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.3-1
- version update
* Wed Dec 08 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.2-1
- version update
* Mon Aug 23 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.9.0-1
- version update
* Sat Aug 14 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.8.2-1
- version update
* Fri Mar 26 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.7.3-2
- adjusted default font path, hopefully fixes bug #0000052 
* Wed Dec 09 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.7.3-1
- version update
* Sun Nov 29 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.7.2-1
- version update
* Sun Nov 01 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.7.1-1
- version update
* Tue Oct 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.7.0.902-1
- version update (1.7.1 rc2)
* Fri May 21 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.6.1.901-1
- Version update (1.6.2 rc1)
- disabled Xnest and DMX (header incompatibility)
* Wed Apr 15 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.6.1-1
- Version update
* Fri Feb 27 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.6.0-1
- Version update
* Wed Jan 07 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.5.99.3-1
- Version update
* Thu Nov 06 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.3-1
- Version update
* Fri Oct 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.2-1
- Version update
* Thu Oct 09 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.1-3
- cleaned up specfile, removed unneccessary conversion scriplet, reordered default fontpath
* Wed Oct 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.1-2
- fixed default fonts path
* Sun Sep 28 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.5.1-1
- Version update
* Sat Sep 06 2008 Stefan Gottwald <gotti@ccux-linux.de> 1.5.0
- Version update
* Sat Sep 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.4-1
- Version update
* Sat Jun 23 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.0.0-2
- rebuilt against Mesa 7.0
* Mon Jun 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.3.0.0-1
- Version update
* Sat Apr 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1.2.0-1
- Version update
* Tue Nov 14 2006 Christian Metzen <metzench@ccux-linux.de> 1.1.1-4
- rebuilt against latest libdrm
* Thu Sep 14 2006 Christian Metzen <metzench@ccux-linux.de> 1.1.1-3
- Fontpath updating for existing xorg.conf
* Mon Sep 11 2006 Christian Metzen <metzench@ccux-linux.de> 1.1.1-2
- modified requires and obsoletes for old version
* Sun Sep 10 2006 Christian Metzen <metzench@ccux-linux.de> 1.1.1-1
- Version update
* Sun Jul 02 2006 Christian Metzen <metzench@ccux-linux.de> 1.1.0-1
- Initial release
